// IoTSSDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IoTSS.h"
#include "IoTSSDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIoTSSDlg dialog

CIoTSSDlg::CIoTSSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIoTSSDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIoTSSDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIoTSSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIoTSSDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIoTSSDlg, CDialog)
	//{{AFX_MSG_MAP(CIoTSSDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_SETIOBIT, OnSetiobits)
	ON_BN_CLICKED(BTN_PLAY, OnPlay)
	ON_BN_CLICKED(BTN_LOAD, OnLoad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIoTSSDlg message handlers

BOOL CIoTSSDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIoTSSDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIoTSSDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIoTSSDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CIoTSSDlg::OnOK() 
{
	
//	CDialog::OnOK();
}

void CIoTSSDlg::OnCancel() 
{

	CDialog::OnCancel();
}

void SetSpeakerOn()
{
	__asm
	{
		push eax
		in al, 0x61
		or al, 0x03
		out 0x61, al
		pop eax
	}	
}

void SetSpeakerOff()
{
	__asm
	{
		push eax
		in al, 0x61
		and al, ~0x03
		out 0x61, al
		pop eax
	}	
}

void SetFrequency(unsigned int hertz)
{
	unsigned int divisor = 1193180/hertz;
	__asm
	{
		push eax
		mov al, 0xb6
		out 0x43, al
		mov eax, divisor		
		out 0x42, al
		shr eax,8
		out 0x42,al
		pop eax
	}
}

void Sound(unsigned int hertz, int delay)
{
	SetFrequency(hertz);
	SetSpeakerOn();
    
	Sleep(1000);

	SetSpeakerOff();
}

void PlaySound()
{
	Sound(261, 8);
	Sound(293, 8);
	Sound(329, 8);
}

#include "..\sys\Prism.h"
#include "DrvFunc.h"

HANDLE	G_hDrv = NULL;
#define DRIVE_NAME	"IoTss"

void CIoTSSDlg::OnSetiobits() 
{
	IO_PORT ioPort;

	if(G_hDrv == NULL) return;

	ioPort.nIoPort = 0x61;	
	ioPort.bArrow = TRUE;
	MakeDrvIoControl (G_hDrv, IOCTL_CREATE_CHANGE_IOPM, &ioPort, sizeof(IO_PORT),
					NULL, 0);	

	ioPort.nIoPort = 0x42;	
	ioPort.bArrow = TRUE;
	MakeDrvIoControl (G_hDrv, IOCTL_CREATE_CHANGE_IOPM, &ioPort, sizeof(IO_PORT),
					NULL, 0);	

	ioPort.nIoPort = 0x43;	
	ioPort.bArrow = TRUE;
	MakeDrvIoControl (G_hDrv, IOCTL_CREATE_CHANGE_IOPM, &ioPort, sizeof(IO_PORT),
					NULL, 0);	

}


BOOL CIoTSSDlg::DestroyWindow() 
{
	if(G_hDrv)
	{
		MakeDrvStop(DRIVE_NAME, G_hDrv);
	}	
	return CDialog::DestroyWindow();
}


void CIoTSSDlg::OnPlay() 
{
	PlaySound();
}

void CIoTSSDlg::OnLoad() 
{
	if(G_hDrv == NULL) 
	{
		G_hDrv = MakeDrvSimpleStart(NULL, DRIVE_NAME);
		if(G_hDrv == NULL) return;
	}
	
}
